#include "ti86asm.inc"

.org _asm_exec_ram

  call _clrScrn
  call _homeup

Mainloop1:
  ld hl,Main1table
  call Do_Menu
Mainloop1K:
  call _get_key
  cp K_EXIT
  jp z,Exit
  cp K_MORE
  jp z,Mainloop2
  cp K_F1
  jp z,Sumloop
  cp K_F2
  jp z,Diffloop
  cp K_F3
  jp z,X2loop
  cp K_F4
  jp z,Div2loop
  cp K_F5
  jp z,Otherloop
  jp nz,Mainloop1K
Main1table:
  .dw $0105
  .dw Main15MT
  .dw Main14MT
  .dw Main13MT
  .dw Main12MT
  .dw Main11MT
Main11MT:
.db "Sum",0
Main12MT:
.db "Diff",0
Main13MT:
.db "*2",0
Main14MT:
.db "/2",0
Main15MT:
.db "Other",0

Mainloop2:
  ld hl,Main2table
  call Do_Menu
Mainloop2K:
  call _get_key
  cp K_EXIT
  jp z,Exit
  cp K_MORE
  jp z,Mainloop1
  cp K_F1
  jp z,fminusloop
  cp K_F2
  jp z,f90minusloop
  cp K_F3
  jp z,Anglesloop
  cp K_F4
  jp z,Derivloop
  cp K_F5
  jp z,Integloop
  jp nz,Mainloop2K
Main2table:
  .dw $0005
  .dw Main25MT
  .dw Main24MT
  .dw Main23MT
  .dw Main22MT
  .dw Main21MT
Main21MT:
.db "f(-x)",0
Main22MT:
.db "(90-x)",0
Main23MT:
.db "Angles",0
Main24MT:
.db "Deriv",0
Main25MT:
.db "Integ",0

Sumloop:
  ld hl,Sumtable
  call Do_Menu
SumloopK:
  call _get_key
  cp K_EXIT
  jp z,Mainloop1
  cp K_F1
  jp z,Sum1
  cp K_F2
  jp z,Sum2
  cp K_F3
  jp z,Sum3
  jp nz,SumloopK
Sumtable:
  .dw $0003
  .dw Sum3MT
  .dw Sum2MT
  .dw Sum1MT
Sum1MT:
.db "sin",0
Sum2MT:
.db "cos",0
Sum3MT:
.db "tan",0

Sum1:
  call clear
  jp SumSin
Sum2:
  call clear
  jp SumCos
Sum3:
  call clear
  jp SumTan

Diffloop:
  ld hl,Difftable
  call Do_Menu
DiffloopK:
  call _get_key
  cp K_EXIT
  jp z,Mainloop1
  cp K_F1
  jp z,Diff1
  cp K_F2
  jp z,Diff2
  cp K_F3
  jp z,Diff3
  jp nz,DiffloopK
Difftable:
  .dw $0003
  .dw Diff3MT
  .dw Diff2MT
  .dw Diff1MT
Diff1MT:
.db "sin",0
Diff2MT:
.db "cos",0
Diff3MT:
.db "tan",0

Diff1:
  call clear
  jp DiffSin
Diff2:
  call clear
  jp DiffCos
Diff3:
  call clear
  jp DiffTan

X2loop:
  call clear
  jp X2
Div2loop:
  call clear
  jp Div2

Otherloop:
  ld hl,Othertable
  call Do_Menu
OtherloopK
  call _get_key
  cp K_EXIT
  jp z,Mainloop1
  cp K_F1
  jp z,Other1
  cp K_F2
  jp z,Other2
  cp K_F3
  jp z,Other3
  jp nz,OtherloopK
Othertable:
  .dw $0003
  .dw Other3MT
  .dw Other2MT
  .dw Other1MT
Other1MT:
.db "sin",0
Other2MT:
.db "cos",0
Other3MT:
.db "+",0

Other1:
  call clear
  jp OtherSin
Other2:
  call clear
  jp OtherCos
Other3:
  call clear
  jp OtherPlus

fminusloop:
  call clear
  jp fminus

f90minusloop:
  call clear
  jp f90minus

Anglesloop:
  call clear
  jp Angles

Derivloop:
  ld hl,Derivtable
  call Do_Menu
DerivloopK:
  call _get_key
  cp K_EXIT
  jp z,Mainloop1
  cp K_F1
  jp z,dtrigloop
  cp K_F2
  jp z,dinvtrigloop
  jp nz,DerivloopK
Derivtable:
  .dw $0002
  .dw Deriv2MT
  .dw Deriv1MT
Deriv1MT:
.db "trig",0
Deriv2MT:
.db "trig",Linverse,0

dtrigloop:
  call clear
  jp dtrig

dinvtrigloop:
  call clear
  jp dinvtrig

Integloop:
  ld hl,Integtable
  call Do_Menu
IntegloopK:
  call _get_key
  cp K_EXIT
  jp z,Mainloop1
  cp K_F1
  jp z,itrigloop
  cp K_F2
  jp z,iinvtrigloop
  cp K_F3
  jp z,iotherloop
  jp nz,IntegloopK
Integtable:
  .dw $0003
  .dw Integ3MT
  .dw Integ2MT
  .dw Integ1MT
Integ1MT:
.db "trig",0
Integ2MT:
.db "trig",Linverse,0
Integ3MT:
.db "other",0
itrigloop:
  call clear
  jp itrig
iinvtrigloop:
  call clear
  jp iinvtrig
iotherloop:
  call clear
  call iother

Exit:
  call _clrScrn
  call _homeup
  call _flushallmenus
  res 4,(iy+9) ;reset on press
  ret

clear:
  call _clrScrn
  call _homeup
  ret

put:
  call _puts
  call _newline
  ret

SumSin:
  ld hl,SumSinT
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
SumSinT:
.db "sin(A+B)=",0
.db "sinAcosB+cosAsinB",0
.db "",0
.db "sinx+siny=",0
.db "2sin(x+y)cos(x-y)",0
.db "      2       2",0

SumCos:
  ld hl,SumCosT
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
SumCosT:
.db "cos(A+B)=",0
.db "cosAcosB-sinAsinB",0
.db "",0
.db "cosx+cosy=",0
.db "2cos(x+y)cos(x-y)",0
.db "      2       2",0

SumTan:
  ld hl,SumTanT
  call put
  call _puts
  jp Mainloop1
SumTanT:
.db "tan(A+B)= tanA+tanB",0
.db "         1-tanAtanB",0

DiffSin:
  ld hl,DiffSinT
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
DiffSinT:
.db "sin(A-B)=",0
.db "sinAcosB-cosAsinB",0
.db "",0
.db "sinx-siny=",0
.db "2cos(x+y)sin(x-y)",0
.db "      2       2",0

DiffCos:
  ld hl,DiffCosT
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
DiffCosT:
.db "cos(A-B)=",0
.db "cosAcosB-sinAsinB",0
.db "",0
.db "cosx-cosy=",0
.db "-2sin(x+y)sin(x-y)",0
.db "       2       2",0

DiffTan:
  ld hl,DiffTanT
  call put
  call _puts
  jp Mainloop1
DiffTanT:
.db "tan(A-B)= tanA-tanB",0
.db "         1+tanAtanB",0

X2:
  ld hl,X2T
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
X2T:
.db "sin2x=2sinxcosx",0
.db "cos2x=cos",Lsquare,"x-sin",Lsquare,"x",0
.db "cos2x=1-2sin",Lsquare,"x",0
.db "cos2x=2cos",Lsquare,"x-1",0
.db "tan2x= 2tanx",0
.db "      1-tan",Lsquare,"x",0

Div2:
  ld hl,Div2T
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
Div2T:
.db "sinx=+/-",Lroot,"(1-cosx)",0
.db "   2        2",0
.db "",0
.db "cosx=+/-",Lroot,"(1+cosx)",0
.db "   2        2",0

OtherSin:
  ld hl,OtherSinT
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
OtherSinT:
.db "sinAcosB=",0
.db ".5(sin(A+B)+sin(A-B)",0
.db "",0
.db "sinAsinB=",0
.db ".5(cos(A-B)-cos(A+B)",0

OtherCos:
  ld hl,OtherCosT
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
OtherCosT:
.db "cosAsinB=",0
.db ".5(sin(A+B)-sin(A-B)",0
.db "",0
.db "cosAcosB=",0
.db ".5(cos(A+B)+cos(A-B)",0

OtherPlus:
  ld hl,OtherPlusT
  call put
  call put
  call _puts
  jp Mainloop1
OtherPlusT:
.db "cos",Lsquare,"x+sin",Lsquare,"x=1",0
.db "1+cot",Lsquare,"x=csc",Lsquare,"x",0
.db "tan",Lsquare,"x+1+sec",Lsquare,"x",0

fminus:
  ld hl,fminusT
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
fminusT:
.db "sin(-x)=-sin x",0
.db "cos(-x)= cos x",0
.db "tan(-x)=-tan x",0
.db "csc(-x)=-csc x",0
.db "sec(-x)= sec x",0
.db "cot(-x)=-cot x",0

f90minus:
  ld hl,f90minusT
  call put
  call put
  call put
  call put
  call put
  call _puts
  jp Mainloop1
f90minusT:
.db "sin(90-x)= cos x",0
.db "cos(90-x)= sin x",0
.db "tan(90-x)= cot x",0
.db "csc(90-x)= sec x",0
.db "sec(90-x)= csc x",0
.db "cot(90-x)= tan x",0

Angles:
  ld hl,$FC02
  ld de,$0010
  ld a,%00000010
  ld b,$40
  call ALoop1
  ld hl,$FC05
  ld b,$40
  call ALoop1
  ld hl,$FC08
  ld a,%00000001
  ld b,$40
  call ALoop1
  ld hl,$FC0C
  ld a,%10000000
  ld b,$40
  call ALoop1
  ld hl,$FC90
  ld de,$FC91
  ld bc,$000F
  ld a,%11111111
  ld (hl),a
  ldir

  ld b,$00
  ld c,$00
  ld (_penCol),bc
  ld hl,AC1T
  call _vputs
  ld b,12
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,18
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,24
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,30
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,36
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,42
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,48
  ld c,$00
  ld (_penCol),bc
  call _vputs
  ld b,54
  ld c,$00
  ld (_penCol),bc
  call _vputs

  ld b,$00
  ld c,26
  ld (_penCol),bc
  ld hl,AC2T
  call _vputs
  ld b,12
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,18
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,24
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,30
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,36
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,42
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,48
  ld c,26
  ld (_penCol),bc
  call _vputs
  ld b,54
  ld c,26
  ld (_penCol),bc
  call _vputs

  ld b,$00
  ld c,51
  ld (_penCol),bc
  ld hl,AC3T
  call _vputs
  ld b,12
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,18
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,24
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,30
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,36
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,42
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,48
  ld c,51
  ld (_penCol),bc
  call _vputs
  ld b,54
  ld c,51
  ld (_penCol),bc
  call _vputs

  ld b,$00
  ld c,76
  ld (_penCol),bc
  ld hl,AC4T
  call _vputs
  ld b,12
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,18
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,24
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,30
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,36
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,42
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,48
  ld c,76
  ld (_penCol),bc
  call _vputs
  ld b,54
  ld c,76
  ld (_penCol),bc
  call _vputs

  ld b,$00
  ld c,101
  ld (_penCol),bc
  ld hl,AC5T
  call _vputs
  ld b,12
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,18
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,24
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,30
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,36
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,42
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,48
  ld c,101
  ld (_penCol),bc
  call _vputs
  ld b,54
  ld c,101
  ld (_penCol),bc
  call _vputs

  call _getkey
  call clear
  jp Mainloop1
ALoop1:
  ld (hl),a
  add hl,de
  djnz ALoop1
  ret

AC1T:
.db "Rad",0
.db "0",0
.db Lpi,"/6",0
.db Lpi,"/4",0
.db Lpi,"/3",0
.db Lpi,"/2",0
.db Lpi,0
.db "3",Lpi,"/2",0
.db "2",Lpi,0
AC2T:
.db "Sin",0
.db "0",0
.db "1/2",0
.db Lroot,"2/2",0
.db Lroot,"3/2",0
.db "1",0
.db "0",0
.db "-1",0
.db "0",0
AC3T:
.db "Cos",0
.db "1",0
.db Lroot,"3/2",0
.db Lroot,"2/2",0
.db "1/2",0
.db "0",0
.db "-1",0
.db "0",0
.db "1",0
AC4T:
.db "Tan",0
.db "0",0
.db Lroot,"3/3",0
.db "1",0
.db Lroot,"3",0
.db "Und",0
.db "0",0
.db "Und",0
.db "0",0
AC5T:
.db "Deg",0
.db "0",0
.db "30",0
.db "45",0
.db "60",0
.db "90",0
.db "180",0
.db "270",0
.db "360",0

dtrig:
  ld hl,dtrigT
  call put
  call put
  call put
  call _puts
  call _puts
  call _puts
  jp Mainloop1
dtrigT:
.db "dsin(x)= cosx dx",0
.db "dcos(x)=-sinx dx",0
.db "dtan(x)= sec",Lsquare,"x dx",0
.db "dcsc(x)=-cscx cotx dx",0
.db "dsec(x)= secx tanx dx",0
.db "dcot(x)=-csc",Lsquare,"x dx",0

dinvtrig:
  ld hl,dinvtrigT
  ld bc,$0000
  ld (_penCol),bc
  call _vputs
  ld bc,$0600
  ld (_penCol),bc
  call _vputs
  ld bc,$0C00
  ld (_penCol),bc
  call _vputs
  ld bc,$1200
  ld (_penCol),bc
  call _vputs
  ld bc,$1800
  ld (_penCol),bc
  call _vputs
  ld bc,$1E00
  ld (_penCol),bc
  call _vputs
  ld bc,$0040
  ld (_penCol),bc
  call _vputs
  ld bc,$0640
  ld (_penCol),bc
  call _vputs
  ld bc,$0C40
  ld (_penCol),bc
  call _vputs
  ld bc,$1240
  ld (_penCol),bc
  call _vputs
  ld bc,$1840
  ld (_penCol),bc
  call _vputs
  ld bc,$1E40
  ld (_penCol),bc
  call _vputs
  jp Mainloop1
dinvtrigT:
.db "dsin",Linverse,"x=                1    dx",0
.db "                  a     ",Lroot,"(a",Lsquare,"-x",Lsquare,")",0
.db "dcos",Linverse,"x=             -1    dx",0
.db "                    a     ",Lroot,"(a",Lsquare,"-x",Lsquare,")",0
.db "dtan",Linverse,"x=        a   dx",0
.db "                    a     a",Lsquare,"+x",Lsquare,0

.db "dcsc",Linverse,"x=             -a   dx",0
.db "                    a     x",Lroot,"(x",Lsquare,"-a",Lsquare,")",0
.db "dsec",Linverse,"x=             a   dx",0
.db "                    a     x",Lroot,"(x",Lsquare,"-a",Lsquare,")",0
.db "dcot",Linverse,"x=      -a   dx",0
.db "                    a      a",Lsquare,"+x",Lsquare,0

itrig:
  ld hl,itrigT
  ld bc,$0000
  ld (_penCol),bc
  call _vputs
  ld bc,$0600
  ld (_penCol),bc
  call _vputs
  ld bc,$0C00
  ld (_penCol),bc
  call _vputs
  ld bc,$1200
  ld (_penCol),bc
  call _vputs
  ld bc,$1800
  ld (_penCol),bc
  call _vputs
  ld bc,$1E00
  ld (_penCol),bc
  call _vputs
  jp Mainloop1
itrigT:
.db Lintegral,"sinx dx=-cosx + C",0
.db Lintegral,"cosx dx=sinx + C",0
.db Lintegral,"tanx dx=ln|secx| + C",0
.db Lintegral,"cscx dx=ln|cscx-cotx| + C",0
.db Lintegral,"secx dx=ln|secx+tanx| + C",0
.db Lintegral,"cotx dx=ln|sinx| + C",0

iinvtrig:
  ld hl,iinvtrigT
  ld bc,$0000
  ld (_penCol),bc
  call _vputs
  ld bc,$0600
  ld (_penCol),bc
  call _vputs
  jp Mainloop1
iinvtrigT:
.db Lintegral,"sin",Linverse,"x dx=xsin",Linverse,"x+(1/a)",Lroot,"(1-x",Lsquare,") + C",0
.db Lintegral,"tan",Linverse,"x dx=xtan",Linverse,"x-(1/2)ln(1+x",Lsquare,") + C",0
iother:
  ld hl,iotherT
  call put
  call put
  call _puts
  call _puts
  jp Mainloop1
iotherT:
.db Lintegral,"sec",Lsquare,"x dx=tanx + C",0
.db Lintegral,"csc",Lsquare,"x dx=-cotx + C",0
.db Lintegral,"secxtanx dx=secx + C",0
.db Lintegral,"cscxcotx dx=-cscx +C",0

#include "Do_Menu.inc"

.end